﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;                                   //ahahahhaah! your GAY ahahahahahaahhaha! get rek stinky b🖕🖕ch! 

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hammer"),
                    NameOverride = "Mjolnir -THR",
                    NameToOrderByOverride = "thor",
                    DescriptionOverride = "A Very Iconic And Powerful Hammer",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("hamView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ham.png");
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 20;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;

                        Instance.FixColliders();

                        UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
                        useEventTrigger.Event = new UnityEvent();
                        useEventTrigger.Event.AddListener(delegate ()
                        {
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale *= -0.9f;
                        ModAPI.CreateParticleEffect("Explosion", Instance.transform.position);
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 20;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 100f;
                        });

                        foreach (var hitbox in Instance.GetComponents<Collider2D>()) { GameObject.Destroy(hitbox); }

                        var head = Instance.gameObject.AddComponent<BoxCollider2D>();
                        head.offset = new Vector2(0f, 0.3f);
                        head.size = new Vector2(0.4f, 0.3f);

                        var stick = Instance.gameObject.AddComponent<BoxCollider2D>();
                        stick.size = new Vector2(0.07f, 0.87f);
                        var web = Instance.AddComponent<hammer>();
                        Instance.AddComponent<EMP3>();
                        Instance.AddComponent<EMP5>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Thor -THR",
                    DescriptionOverride = "He is the God of Thunders ;o;",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thor.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");


                        GameObject alsoEye = new GameObject();
                        alsoEye.transform.parent = head;
                        alsoEye.transform.localPosition = new Vector3(0f, 0f);
                        alsoEye.transform.localScale = new Vector3(1f, 1f);

                        var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

                        eyeSprite.sprite = ModAPI.LoadSprite("eye.png");
                        eyeSprite.material = ModAPI.FindMaterial("VeryBright");
                        eyeSprite.color = new Color(0f, 0.5f, 1f, 0.25f);
                        eyeSprite.sortingLayerName = "Top";

                        var eye = ModAPI.CreateLight(head, Color.cyan, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                       GameObject wings = new GameObject();
                        wings.transform.parent = upper;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("cape.png");
                        wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
                        wingsprite.color = new Color(1f, 0f, 0f, 1f);
                        wingsprite.sortingLayerName = "Top";

                        head.gameObject.AddComponent<EMP>();

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 2f;
                            body.Health *= 1000f;
                            body.InitialHealth *= 1000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 10000f;
                            body.gameObject.AddComponent<Awake>();
                            body.gameObject.AddComponent<Awake1>();
                            body.gameObject.AddComponent<Awake5>();
                            body.CirculationBehaviour.BloodFlow *= 4f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                        }

                        var skin = ModAPI.LoadTexture("skin.png");
                        var flesh = ModAPI.LoadTexture("skin.png");
                        var bone = ModAPI.LoadTexture("th.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
        person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(10, 10, 10); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(10, 10, 10);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Thor (WITH POWERS DISABLED) -THR",
                    DescriptionOverride = "He lost his powers... at least camodo gaming will be able to kill him lol",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thor2.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var upper = Instance.transform.Find("Body").Find("UpperBody");

                       GameObject wings = new GameObject();
                        wings.transform.parent = upper;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("cape.png");
                        wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
                        wingsprite.color = new Color(1f, 0f, 0f, 1f);
                        wingsprite.sortingLayerName = "Top";


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 2f;
                            body.Health += 10000f;
                            body.InitialHealth += 10000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 10000f;
                            body.gameObject.AddComponent<Awake>();
                            body.CirculationBehaviour.BloodFlow *= 4f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                        }


                        var skin = ModAPI.LoadTexture("skin.png");
                        var flesh = ModAPI.LoadTexture("skin.png");
                        var bone = ModAPI.LoadTexture("bone1.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Thor (ONLY REGENERATION) -THR",
                    DescriptionOverride = "He is like the mortal one but this one got the regeneration power only.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thor3.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var upper = Instance.transform.Find("Body").Find("UpperBody");

                       GameObject wings = new GameObject();
                        wings.transform.parent = upper;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("cape.png");
                        wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
                        wingsprite.color = new Color(1f, 0f, 0f, 1f);
                        wingsprite.sortingLayerName = "Top";


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 2f;
                            body.Health += 10000f;
                            body.InitialHealth += 10000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 10000f;
                            body.gameObject.AddComponent<Awake>();
                            body.gameObject.AddComponent<Awake1>();
                            body.CirculationBehaviour.BloodFlow *= 4f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                        }


                        var skin = ModAPI.LoadTexture("skin.png");
                        var flesh = ModAPI.LoadTexture("skin.png");
                        var bone = ModAPI.LoadTexture("bone1.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
            //stormbreaker
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "Stormbreaker -THR",
                    DescriptionOverride = "Funny fact: Stormbreaker was my xbox username 2 years ago lol",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("stormView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pickaxehead.png");
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 80;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass *= 1.4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= 1.4f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass *= 1.4f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
                        Instance.FixColliders();
                        UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
                        useEventTrigger.Event = new UnityEvent();
                        useEventTrigger.Event.AddListener(delegate ()
                        {
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale *= -1.5f;
                        ModAPI.CreateParticleEffect("Explosion", Instance.transform.position);
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 100;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 100f;
                        });

                        foreach (var hitbox in Instance.GetComponents<Collider2D>()) { GameObject.Destroy(hitbox); }

                        var head = Instance.gameObject.AddComponent<BoxCollider2D>();
                        head.offset = new Vector2(0f, 0.3f);
                        head.size = new Vector2(0.4f, 0.3f);

                        var stick = Instance.gameObject.AddComponent<BoxCollider2D>();
                        stick.size = new Vector2(0.07f, 0.87f);
                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(hitbox);
                        }
                        Instance.AddComponent<HingeJointLimitAutofixBehaviour>();
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("storm.png");
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 50;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass *= 1.4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= 1.4f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass *= 1.4f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        var prop = ModAPI.FindPhysicalProperties("Metal");
                        prop.Sharp = true;
                        prop.SharpAxes = new[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.5f, true, false),
                            new SharpAxis(Vector2.left, 0f, 0.5f, true, false)
                        };

                        var PickHead = Instance.AddComponent<BoxCollider2D>();
                        PickHead.size = new Vector2(0.7f, 0.20f);
                        PickHead.offset = new Vector2(0f, 0f);

                        var PickHandle = Instance.transform.GetChild(0).GetComponent<BoxCollider2D>();
                        PickHandle.offset = new Vector2(0f, 0f);
                        PickHandle.size = new Vector2(0.11f, 1.8f);
                        Instance.transform.GetChild(0).localPosition = Vector3.down * 1.52f / 2;
                        Instance.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                        Instance.GetComponent<FixedJoint2D>().autoConfigureConnectedAnchor = true;
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 50;

                        var childphys = Instance.GetComponent<PhysicalBehaviour>();
                        childphys.BakeColliderGridPoints();
                        childphys.Properties = prop;
                        var web = Instance.AddComponent<hammer>();

                        Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new[]
{
                            new Vector3(0f, -0.7f)
                        };
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Spear"),
                    NameOverride = "Loki's Scepter -THR",
                    NameToOrderByOverride = "thor",
                    DescriptionOverride = "Loki's Powerful Staff",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("staffView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("loki.png");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1.2f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1.2f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1.2f;

        	var childObject = new GameObject("the mf glow");
						childObject.transform.SetParent(Instance.transform);
						childObject.transform.localPosition = new Vector3(0f, 0f);
						childObject.transform.localScale = new Vector3(1f, 1f);
						var childSprite = childObject.AddComponent<SpriteRenderer>();
						childSprite.sprite = ModAPI.LoadSprite("shiny.png");
						childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						childSprite.sortingLayerName = "Top";

                        Instance.FixColliders();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        var prop = ModAPI.FindPhysicalProperties("Metal");

                        Instance.AddComponent<CategoryBuilder>();
                        Instance.AddComponent<EMP4>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Loki -THR",
                    DescriptionOverride = "He is a bit crazy O-O",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("lokicon.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var upper = Instance.transform.Find("Body").Find("UpperBody");

                       GameObject wings = new GameObject();
                        wings.transform.parent = upper;
                        wings.transform.localPosition = new Vector4(0f, 0f);
                        wings.transform.localScale = new Vector4(1f, 1f);

                        var wingsprite = wings.AddComponent<SpriteRenderer>();

                        wingsprite.sprite = ModAPI.LoadSprite("cape1.png");
                        wingsprite.material = ModAPI.FindMaterial("Sprites-Default");
                        wingsprite.color = new Color(0.1f, 1f, 0f, 1f);
                        wingsprite.sortingLayerName = "Top";

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 2f;
                            body.Health += 10000f;
                            body.InitialHealth += 10000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 10000f;
                            body.gameObject.AddComponent<Awake>();
                            body.CirculationBehaviour.BloodFlow *= 4f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                        }


                        var skin = ModAPI.LoadTexture("skin1.png");
                        var flesh = ModAPI.LoadTexture("skin1.png");
                        var bone = ModAPI.LoadTexture("bone1.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Loki's Crown -THR",
                    NameToOrderByOverride = "thor",
                    DescriptionOverride = "Its just his helmet...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("crown1.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("crown.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 3;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Super-Charged Mjolnir -THR",
                    NameToOrderByOverride = "thor",
                    DescriptionOverride = "HOLY SHI-*death*",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("ham1View.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ham1.png");

                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("thunder.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("*");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 50f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 100f;

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");

                        var childObject = new GameObject("glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("light.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 100;
                        var web = Instance.AddComponent<hammer>();
                        Instance.AddComponent<EMP3>();
                        Instance.AddComponent<EMP5>();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                        Instance.GetComponent<PhysicalBehaviour>().Charge = 100;
                        };
		    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Landmine"),
                    NameOverride = "*",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "Its nothing... ",
                    CategoryOverride = ModAPI.FindCategory("l'egg"),
                    ThumbnailOverride = ModAPI.LoadSprite("hamView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var childObject = new GameObject("glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("th.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("th.png");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1.2f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1.2f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1.2f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.5f;
                        Instance.FixColliders();

                        Instance.AddComponent<EMP3>();
                    }
                }
            );

        }
    }
}